unit DemoDlp;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ShellApi, ExtCtrls, StdCtrls, uCalcDlp;

type
  TForm1 = class(TForm)
    txtExpression: TEdit;
    txtDefinition: TEdit;
    txtSumMax: TEdit;
    txtSumExpression: TEdit;
    txtPlotEq: TEdit;
    txtSumResult: TEdit;
    txtResult: TEdit;
    btnEval: TButton;
    btnDefine: TButton;
    btnSum: TButton;
    btnPlot: TButton;
    lblExpression: TLabel;
    lblResult: TLabel;
    lblDefinition: TLabel;
    Label4: TLabel;
    lblSumExpression: TLabel;
    lblSumResult: TLabel;
    Image1: TImage;
    lblElapsed: TLabel;
    lbl_ExprEval: TLabel;
    lblSpeedTest: TLabel;
    lbl_UserDefs: TLabel;
    lblEqPlotter: TLabel;
    lblEvalSource2: TLabel;
    lblEvalSource: TLabel;
    lblDefineSource: TLabel;
    lblDefineSource2: TLabel;
    chkExprEvalExamples: TCheckBox;
    chkDefExamples: TCheckBox;
    lblFPU: TLabel;
    chkInvalidOp: TCheckBox;
    chkDenormalOp: TCheckBox;
    chkDivisionBy0: TCheckBox;
    chkOverflow: TCheckBox;
    chkUnderflow: TCheckBox;
    chkPrecisionLoss: TCheckBox;
    procedure btnSumClick(Sender: TObject);
    procedure btnEvalClick(Sender: TObject);
    procedure btnDefineClick(Sender: TObject);
    procedure btnPlotClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure txtExpressionChange(Sender: TObject);
    procedure txtDefinitionChange(Sender: TObject);
    procedure chkExprEvalExamplesClick(Sender: TObject);
    procedure chkDefExamplesClick(Sender: TObject);
    procedure txtExpressionKeyPress(Sender: TObject; var Key: Char);
    procedure txtPlotEqKeyPress(Sender: TObject; var Key: Char);
    procedure chkInvalidOpClick(Sender: TObject);
    procedure chkDenormalOpClick(Sender: TObject);
    procedure chkDivisionBy0Click(Sender: TObject);
    procedure chkOverflowClick(Sender: TObject);
    procedure chkUnderflowClick(Sender: TObject);
    procedure chkPrecisionLossClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  H, W: Variant; { Image1 Height and Width }

implementation

{$R *.DFM}

procedure CartesianLineTo(a: Variant; b: Variant);
var
  x, y: Integer;
begin
  x := W * (a + 10) / 20;
  y := H * (2 - b) / 4;
  Form1.Image1.Canvas.LineTo(x, y);
end;


// uCalc callback routines

// IMPORTANT: Always remember to use  stdcall  for uCalc callbacks
procedure MyArea(Expr: Longword); stdcall;
var
   MyLength, MyWidth: Extended;
begin
   MyLength := ucParam(Expr, 1);
   MyWidth := ucParam(Expr, 2);   
   
   if MyLength < 0 then ucRaiseErrorMessage(Expr, 'Length cannot be negative');
   if MyWidth  < 0 then ucRaiseErrorMessage(Expr, 'Width cannot be negative');

   ucReturn(Expr, MyLength * MyWidth);
end;

// IMPORTANT: Always remember to use  stdcall  for uCalc callbacks
function NonNativeFunc(a: Double; var b: Longint; c: Byte): Extended; stdcall;
begin
   NonNativeFunc := a + b + c;
end;

// IMPORTANT: Always remember to use  stdcall  for uCalc callbacks
procedure MyIIF_Numeric(Expr: Longword); stdcall;
var
   Condition: Extended;
   TruePart, FalsePart: Longword;
begin
   Condition := ucParam(Expr, 1);
   TruePart  := ucParamHandle(Expr, 2);
   FalsePart := ucParamHandle(Expr, 3);

   if Condition <> 0 
   then ucReturn(Expr, ucEvaluate(TruePart)) 
   else ucReturn(Expr, ucEvaluate(FalsePart));
end;

// IMPORTANT: Always remember to use  stdcall  for uCalc callbacks
procedure MyIIF_String(Expr: Longword); stdcall;
var
   Condition: Extended;
   TruePart, FalsePart: Longword;
begin
   Condition := ucParam(Expr, 1);
   TruePart  := ucParamHandle(Expr, 2);
   FalsePart := ucParamHandle(Expr, 3);

   if Condition <> 0 
   then ucReturnStr(Expr, ucEvaluateStr(TruePart)) 
   else ucReturnStr(Expr, ucEvaluateStr(FalsePart));
end;

// IMPORTANT: Always remember to use  stdcall  for uCalc callbacks
procedure Native_MsgBox(Expr: Longword); stdcall;
begin
   // The 2nd and 3rd args are swapped so that MsgBox is uniform with the demo for VB and other compilers
   ucReturn(Expr, Application.MessageBox(ucParamStr(Expr, 1), ucParamStr(Expr, 3), Trunc(ucParam(Expr, 2))));
end;

// IMPORTANT: Always remember to use  stdcall  for uCalc callbacks
function nn_MsgBox(var Prompt: AnsiString; Buttons: Longint; var Title: AnsiString): Longint; stdcall;
begin
   nn_MsgBox := Application.MessageBox(PChar(Prompt), PChar(Title), Buttons);
end;

// IMPORTANT: Always remember to use  stdcall  for uCalc callbacks
procedure MyAverage(Expr: Longword); stdcall;
var
   x: Longint;
   Total: Extended;
begin
   Total := 0;
   for x := 1 to ucParamCount(Expr) do Total := Total + ucParam(Expr, x);
   ucReturn(Expr, Total / ucParamCount(Expr));
end;

// IMPORTANT: Always remember to use  stdcall  for uCalc callbacks
procedure MyLeft(Expr: Longword); stdcall;
begin
   ucReturnStr(Expr, copy(ucParamStr(Expr, 1), 1, Trunc(ucParam(Expr, 2))));
end;

// IMPORTANT: Always remember to use  stdcall  for uCalc callbacks
procedure StringRepeat(Expr: Longword); stdcall;
var
   x: Longint;
   TotalString: AnsiString;
begin
   TotalString := '';
   for x := 1 To Trunc(ucParam(Expr, 2))
   do TotalString := TotalString + ucParamStr(Expr, 1);
   ucReturnStr(Expr, TotalString);
end;

// IMPORTANT: Always remember to use  stdcall  for uCalc callbacks
var AlreadyDisplayedOnce: Longint = 0;
function MyErrorHandler(t: Longword): Longword; stdcall;
begin
   if AlreadyDisplayedOnce = ucFalse then
      ShowMessage('Error Handler message: ' + ucErrorMessage(0, t) + Chr(13)
         + 'Offending symbol: ' + ucErrSymbol(t) + Chr(13)
         + 'Error Location: ' + IntToStr(ucErrLocation(t)) + Chr(13) + Chr(13)
         + 'This message box will not be displayed for the next error.' + Chr(13)
         + 'Remove "AlreadyDisplayedOnce := ucTrue;" in the demo source code to change this.');
   
   // Remove the line below if you want the message box to be
   // displayed every time there's an error.
   AlreadyDisplayedOnce := ucTrue;
   MyErrorHandler := ucAbort;
end;

// IMPORTANT: Always remember to use  stdcall  for uCalc callbacks
procedure ucSum(Expr: Longword); stdcall;
var
   Expression, VarHandle: Longword;
   Start, Finish, sStep: Extended;
   x, Total: Extended;
begin
   Expression := ucParamHandle(Expr, 1);
   Start      := ucParam(Expr, 2);
   Finish     := ucParam(Expr, 3);
   sStep      := ucParam(Expr, 4);
   VarHandle  := ucParamHandle(Expr, 5);

   x := Start;
   Total := 0;
   while x <= Finish do
   begin
      ucSetVariableValue(VarHandle, x);
      Total := Total + ucEvaluate(Expression);
      x := x + sStep;
   end;

   ucReturn(Expr, Total);
end;

// IMPORTANT: Always remember to use  stdcall  for uCalc callbacks
procedure ucSolve(Expr: Longword); stdcall;
var
   Expression, Variable, Iterations: Longword;
   a, b, fa, fb, Value, tmp: Double;
begin
   Expression := ucParamHandle(Expr, 1);
   a := ucParam(Expr, 2);
   b := ucParam(Expr, 3);
   Variable := ucParamHandle(Expr, 4);
   Iterations := 0;

   ucSetVariableValue(Variable, a); fa := ucEvaluate(Expression);
   ucSetVariableValue(Variable, b); fb := ucEvaluate(Expression);

   if fb < fa then
   begin  // swap a, b
      tmp := a;
      a := b;
      b := tmp;
   end;

   while Abs(b - a) > 0.000000000000001 do
   begin
      ucSetVariableValue(Variable, (a + b) / 2);

      Value := ucEvaluate(Expression);

      if Value = 0 then begin a := (a + b) / 2; Break; end;

      if Value < 0
      then a := (a + b) / 2
      else b := (a + b) / 2;

      Iterations := Iterations + 1;
      if Iterations = 100 then Break;
   end;

   If Abs(Value) > 0.0000000001 Then ucRaiseErrorMessage(Expr, 'Solution not found');

   ucReturn(Expr, a);
end;

procedure Test(Expr, Answer: string; t: Longword = 0);
begin
   if Answer <> ucEvalStr(Expr, t) then Application.MessageBox(PChar(Expr + Chr(10) + ucEvalStr(Expr, t) + Chr(10) + Answer), '', 0);
end;

procedure TestExpand(Expr, Answer: string; t: Longword = 0);
begin
   if Answer <> ucExpand(Expr, t) then Application.MessageBox(PChar(Expr + Chr(10) + ucExpand(Expr, t) + Chr(10) + Answer), '', 0);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   // The definitions here are for "callback" routines.
   // Each line ends with the address of a routine, with the name of the routine preceded by @.
   // The actual code for these routines can be found elsewhere in this file.
   // Do a search for MyErrorHandler, for instance, to see the actual code for it.
   
   // The MyErrorHandler() function will be called whenever and wherever an
   // error (such as "Syntax Error") is raised.
   uCalc(uc_AddErrorHandler, 0, Longword(@MyErrorHandler));

   // Native callback definitions, which start with "Native: " are recommended for
   // speed, and for routines that use uCalc's default numeric and string types.
   // MyArea() returns the product of multiplying the two arguments.
   // MyLeft() returns the left-most characters of a string.  The second argument represents the number of characters.
   // MsgBox() displays a message box.  The 1st argument is required.  The others are optional.
   ucDefineFunction('Native: MyArea(Length, Width)', @MyArea);
   ucDefineFunction('Native: MyLeft(Text As String, Count) As String', @MyLeft);
   ucDefineFunction('Native: MsgBox(Prompt As String, Buttons = 0, Title As String = "uCalc")', @Native_MsgBox);

   // The three consecutive dots "..." mean that MyAverage can take any number of arguments
   // (however, because "x" is specified, there must be at least one argument).
   ucDefineFunction('Native: MyAverage(x ...)', @MyAverage);

   // Two versions of MyIIF can co-exist peacefully with the same name because
   // they are defined with different argument types (numeric vs string).
   // By passing the last two arguments ByExpr, the callback can chose to evaluate only one of of them.
   ucDefineFunction('Native: MyIIf(ByVal cond, ByExpr TruePart, ByExpr FalsePart)', @MyIIF_Numeric);
   ucDefineFunction('Native: MyIIf(ByVal cond, ByExpr TruePart As String, ByExpr FalsePart As String) As String', @MyIIF_String);

   // The following defines the "*" operator so that MyString * n returns MyString repeated n times.
   // For instance, "He " * 3, would return "He He He".  20 represents the precedence level.  It is
   // arbitrarily set at the same level as that of the "*" multiplication operator defined in uCalcDlp.Pas.
   ucDefineOperator('Native: 20 {MyString As String} * {Number} As String', @StringRepeat);

   // Non-native callbacks are intended for routines that were not created with
   // uCalc in mind, such as the Windows API, or other pre-existing DLL routines.
   // It is convenient (no need to adapt the routines; all you need is a function
   // address), but not as fast as Native callbacks.
   // NonNativeFunc() simply adds the three arguments.
   // nn_MsgBox is a Non-Native version of MsgBox, which displays a message box.
   ucDefineFunction('NonNativeFunc(ByVal a As Double, ByRef b As Long, ByVal c As Byte) As Extended', @NonNativeFunc);
   ucDefineFunction('nn_MsgBox(ByRef Prompt As String, ByVal Buttons As Long = 0, ByRef Title As String = "uCalc") As Long', @nn_MsgBox);

   // This definition is for a summation.  See the callback ucSum() routine for the
   // actual code, which runs a loop that adds up the total for the expression in
   // the first argument a number of times based on the second and third arguments.
   // For instance Sum(g^2+1, 1, 5, 1, g) returns 60 and Sum(x^2, 1, 10) returns 385.
   // The last two arguments are optional, so they default to 1 and x if omitted.
   //
   // The first argument is passed "ByExpr".  So instead of being evaluated before
   // being passed to the callback the way an ordinary argument would be, a handle
   // for the expression is passed so that the callback can evaluate it (in this
   // case numerous times).
   //
   // The last argument is passed "ByHandle".  This causes the callback to receive
   // a handle for the variable being passed, in such a way that it can be linked to
   // the summation counter, and integrated into the expression in the first argument.
   //
   // The actual function being defined is Sum_().  Then a syntax construct named
   // Sum() is defined in such a way that the last argument gets defined as a local
   // variable.  So if you evaluate Sum(x^2, 5, 10, 1, x), the local "x" in this
   // expression will not interfere with a pre-existing variable named x.  Also you
   // do not need to declare a variable ahead of time to use it as a counter for Sum().
   ucDefineFunction('Native: Sum_(ByExpr Expr, Start, Finish, Step, ByHandle Var)', @ucSum);
   ucDefineSyntax('Sum({Expr}, {Start}, {Finish} [, {Step=1} [, {Var=x}]])'
                + '::= Local({Var}, Sum_({Expr}, {Start}, {Finish}, {Step}, {Var}))');

   // The following routine solves an equation.
   // The callback code is based on the Bisection Method algorithm.
   // The concept here is very similar to that of Sum().
   // Two syntax constructs are defined.  The second one rearranges the equation
   // if it includes an equal sign.
   // For instance Solve(x^2 = 9+x) becomes Solve(x^2 - (9+x))
   // Solve(x^2 + 1 = 26) returns 5.
   // Solve(x^2 + 1 = 26, -1000, 0) returns -5.
   ucDefineFunction('Native: Solve_(ByExpr Expr, a, b, ByHandle Var)', @ucSolve);
   ucDefineSyntax('Solve({Expr} [, {a=-100000000} [, {b=100000000} [, {Var=x}]]]) '
                + '::= Local({Var}, Solve_({Expr}, {a}, {b}, {Var}))');
   ucDefineSyntax('Solve({Left} = {Right} [, {etc}]) ::= Solve({Left}-({Right}) {etc: , {etc}})');

   Image1.Canvas.Rectangle(0, 0, Image1.Width, Image1.Height);
end;

procedure TForm1.btnSumClick(Sender: TObject);
var
   ExprHandle, xHandle: Longword;
   x, SumMax, SumTotal: Extended;
   Code: Integer;
   TimerStart: TDateTime;
   Elapsed: TTimeStamp;
begin   
   x := 1;
   SumTotal := 0;

   xHandle := ucDefineVariable('x', @x);
   ExprHandle := ucParse(txtSumExpression.Text);

   val(txtSumMax.Text, SumMax, Code);
   TimerStart := Time;   

   while x <= SumMax do
   begin
     SumTotal := SumTotal + ucEvaluate(ExprHandle);
     x := x + 1;
   end;

   Elapsed := DateTimeToTimeStamp(Time - TimerStart);
   
   lblElapsed.Caption := 'Elapsed Time: ' + FloatToStr(Elapsed.Time/1000) + ' seconds';
   txtSumResult.Text  := FormatFloat('#', SumTotal);
   
   ucReleaseItem(ExprHandle);
   ucReleaseItem(xHandle);
end;

procedure TForm1.btnEvalClick(Sender: TObject);
begin
   // ucEval() evaluates an expression and returns a numeric result.
   // ucEvalStr() can evaluate expressions of any data type (numeric, string, or other).
   // If the result is numeric ucEvalStr conveniently converts it to a string for you.
   txtResult.Text := ucEvalStr(txtExpression.Text);
end;

procedure TForm1.btnDefineClick(Sender: TObject);
begin
   // ucDefine can define a variable, function, operator, syntax construct,
   // constant, pattern, data type, and more.
   //
   // Examples:
   //
   // ucDefine('Var: MyVariable As String');
   // ucDefine('Func: Area(Length, Width) = Length * Width');
   // ucDefine('Op: 50 {x}%  :=  x / 100');   // 50 is an arbitrary precedence level.
   // ucDefine('Syntax: {a} + {a} ::= "Two {a}s are better than one {a}"');
   // ucDefine('Const: Pi = Atan(1) * 4');
   ucDefine(txtDefinition.Text);
end;

procedure TForm1.btnPlotClick(Sender: TObject);
var
   x: Extended;
   EqHandle, xHandle: Longword;
begin
   Image1.Canvas.FillRect(ClientRect);
   xHandle := ucDefineVariable('x', @x);
   EqHandle := ucParse(txtPlotEq.Text);

   W := Image1.Width;
   H := Image1.Height;
   x := -10;

   Image1.Canvas.MoveTo(0, H/2);

   while x <= 10 do
   begin try
      CartesianLineTo(x, ucEvaluate(EqHandle));
   except end;
      x := x + 0.125;
   end;

   ucReleaseItem(EqHandle);
   ucReleaseItem(xHandle)
end;

procedure TForm1.txtExpressionChange(Sender: TObject);
begin
   lblEvalSource.Caption := 'Expression := ''' + txtExpression.Text + ''';';
end;

procedure TForm1.txtDefinitionChange(Sender: TObject);
begin
   lblDefineSource.Caption := 'Definition := ''' + txtDefinition.Text + ''';'
end;

procedure TForm1.chkExprEvalExamplesClick(Sender: TObject);
var
   EnvVar: AnsiString;
begin
   SetLength(EnvVar, 256);
   GetEnvironmentVariable('COMSPEC', PChar(EnvVar), 255);   
   ShellExecute(0, nil, PChar(EnvVar), '/C notepad DemoExpr.Txt', nil, SW_NORMAL);
end;

procedure TForm1.chkDefExamplesClick(Sender: TObject);
var
   EnvVar: AnsiString;
begin
   SetLength(EnvVar, 256);
   GetEnvironmentVariable('COMSPEC', PChar(EnvVar), 255);   
   ShellExecute(0, nil, PChar(EnvVar), '/C notepad DemoDefs.Txt', nil, SW_NORMAL);
end;

procedure TForm1.txtExpressionKeyPress(Sender: TObject; var Key: Char);
begin
   if Key = #13 then btnEvalClick(Sender);
end;

procedure TForm1.txtPlotEqKeyPress(Sender: TObject; var Key: Char);
begin
   if Key = #13 then btnPlotClick(Sender);
end;

procedure TForm1.chkInvalidOpClick(Sender: TObject);
begin
   // If toggled, then an expression such as 0 / 0 raises an error.
   // If toggled again, then 0 / 0 returns NaN.
   uCalc(uc_ToggleFPU, 0, uc_FPU_Mask_InvalidOp);
end;

procedure TForm1.chkDenormalOpClick(Sender: TObject);
begin
   uCalc(uc_ToggleFPU, 0, uc_FPU_Mask_DenormalOp);
end;

procedure TForm1.chkDivisionBy0Click(Sender: TObject);
begin
   // If toggled, then 1 / 0 raises an error.
   // If toggled again, then 1 / 0 returns Inf.
   uCalc(uc_ToggleFPU, 0, uc_FPU_Mask_ZeroDivide);
end;

procedure TForm1.chkOverflowClick(Sender: TObject);
begin
   // If toggled, then 100! ^ 150 raises an error.
   // If toggled again, then 100! ^ 150 returns Inf.
   uCalc(uc_ToggleFPU, 0, uc_FPU_Mask_Overflow);
end;

procedure TForm1.chkUnderflowClick(Sender: TObject);
begin
   // If toggled, then (1/100!)^150 raises an error.
   // If toggled again, then (1/100!)^150 returns 0.
   uCalc(uc_ToggleFPU, 0, uc_FPU_Mask_Underflow);
end;

procedure TForm1.chkPrecisionLossClick(Sender: TObject);
begin
   // If toggled, an expression that cannot be represented in exact form
   // such as "1/3" will raise an error.
   // If toggled again, "1/3" returns the closest extended precision approximation.
   uCalc(uc_ToggleFPU, 0, uc_FPU_Mask_PrecisionLoss);
end;

end.
