' ------------------------------------------------------------------
' uCalcNET.vb : VB.NET include file for uCalc Fast Math Parser 2.96
' Designed to work with Visual Basic .NET 2003 and above.
'
' Copyright (c) 2007, 2008 by Daniel Corbier.
' Visit www.ucalc.com for additional resources.
' ------------------------------------------------------------------
' Definition properties
Public Module uCalcNET
    Public Const ucAlphaNumeric As Integer = 1
    Public Const ucArgSeparator As Integer = 2
    Public Const ucCodeBlock As Integer = 3
    Public Const ucCodeBlockMatch As Integer = 4
    Public Const ucEvalInsert As Integer = 5
    Public Const ucExpandInsert As Integer = 6
    Public Const ucMemberAccess As Integer = 7
    Public Const ucQuotedText As Integer = 8
    Public Const ucStatementSep As Integer = 9
    Public Const ucWhiteSpace As Integer = 10

    Public Const ucFuncDefEnd As Integer = 11
    Public Const ucCurrentThread As Integer = 12

    Public Const ucPartialBlockStart As Integer = 13
    Public Const ucPartialBlockEnd As Integer = 14

    Public Const ucEvalDuringParse As Integer = 15

    Public Const ucFunction As Integer = 16
    Public Const ucLiteral As Integer = 32
    Public Const ucReducible As Integer = 64
    Public Const ucSymbol As Integer = 128
    Public Const ucVariable As Integer = 256
    Public Const ucInfix As Integer = 512
    Public Const ucPrefix As Integer = 1024
    Public Const ucPostfix As Integer = 2048
    Public Const ucOperator As Integer = 4096
    Public Const ucPassOnce As Integer = 8192
    Public Const ucLock As Integer = 16384


    ' uCalc Commands
    Public Const uc_Define As Integer = 1
    Public Const uc_DefineSyntax As Integer = 2
    Public Const uc_EvalDbl As Integer = 4
    Public Const uc_EvalExt As Integer = 5
    Public Const uc_EvalStr As Integer = 6
    Public Const uc_EvaluateDbl As Integer = 7
    Public Const uc_EvaluateExt As Integer = 8
    Public Const uc_Evaluate As Integer = 8
    Public Const uc_EvaluateLng As Integer = 9
    Public Const uc_EvaluateStr As Integer = 10
    Public Const uc_GetCaseSensitivity As Integer = 11
    Public Const uc_GetCodeAddr As Integer = 12
    Public Const uc_GetDefaultPrecedence As Integer = 13
    Public Const uc_GetDefaultRank As Integer = 14
    Public Const uc_GetDefaultType As Integer = 15
    Public Const uc_GetDefaultThread As Integer = 16
    Public Const uc_GetDefSeparator As Integer = 17
    Public Const uc_GetErrorNumber As Integer = 18
    Public Const uc_GetParentThread As Integer = 19
    Public Const uc_GetSyntaxEqual As Integer = 20
    Public Const uc_Parse As Integer = 21
    Public Const uc_ReleaseItem As Integer = 22
    Public Const uc_SetCaseSensitivity As Integer = 23
    Public Const uc_SetCodeAddr As Integer = 24
    Public Const uc_SetDefaultPrecedence As Integer = 25
    Public Const uc_SetDefaultRank As Integer = 26
    Public Const uc_SetDefaultThread As Integer = 27
    Public Const uc_SetDefaultType As Integer = 28
    Public Const uc_SetDefSeparator As Integer = 29
    Public Const uc_SetErrorNumber As Integer = 30
    Public Const uc_SetParentThread As Integer = 31
    Public Const uc_SetSyntaxEqual As Integer = 32
    Public Const uc_NewThread As Integer = 33
    Public Const uc_PartialBlockCount As Integer = 34

    Public Const uc_RegExWordBoundaryChars As Integer = 35
    Public Const uc_RegExEscapeChar As Integer = 36
    Public Const uc_License As Integer = 37
    Public Const uc_License_Demo As Integer = 0
    Public Const uc_License_Free As Integer = 2
    Public Const uc_License_FMP_Lite As Integer = 3
    Public Const uc_License_FMP_Standard As Integer = 4
    Public Const uc_License_LanguageBuilder As Integer = 5
    Public Const uc_License_Beta As Integer = 6

    Public Const uc_AddErrorHandler As Integer = 40
    Public Const uc_GetSymbolTable As Integer = 41

    Public Const uc_GetCallbackData As Integer = 50
    Public Const uc_SetCallbackReturn As Integer = 51

    Public Const uc_GetExpression As Integer = 60
    Public Const uc_GetExpressionType As Integer = 61
    Public Const uc_GetSymbol As Integer = 62
    Public Const uc_GetItem As Integer = 63
    Public Const uc_GetLocation As Integer = 64

    Public Const uc_GetPatternType As Integer = 65
    Public Const uc_GetPatternProperties As Integer = 66

    Public Const uc_GetTrigMode As Integer = 67
    Public Const uc_SetTrigMode As Integer = 68

    Public Const uc_ItemClone As Integer = 70
    Public Const uc_DataConvert As Integer = 71
    Public Const uc_DataCopy As Integer = 72
    Public Const uc_DataAlloc As Integer = 72
    Public Const uc_DataFree As Integer = 73
    Public Const uc_DataReset As Integer = 74

    Public Const uc_SetFPU As Integer = 75
    Public Const uc_SetFPU_HostProg As Integer = 76
    Public Const uc_GetFPU As Integer = 77
    Public Const uc_GetFPU_HostProg As Integer = 78
    Public Const uc_ToggleFPU As Integer = 79
    Public Const uc_ToggleFPU_HostProg As Integer = 80
    Public Const uc_ErrorClear As Integer = 85

    Public Const uc_SetErrorMessage As Integer = 91
    Public Const uc_GetErrorMessage As Integer = 92

    Public Const uc_SerialNumber As Integer = 93
    Public Const uc_SetTurbo As Integer = 94
    Public Const uc_Expand As Integer = 95
    Public Const uc_GetNextItem As Integer = 96
    Public Const uc_GetItemData As Integer = 97
    Public Const uc_SetItemData As Integer = 98
    Public Const uc_GetThreadAddr As Integer = 99
    Public Const uc_GetCodeBlock As Integer = 100

    Public Const uc_Properties As Integer = 1
    Public Const uc_Thread As Integer = 2
    Public Const uc_Address As Integer = 3
    Public Const uc_SymbolName As Integer = 4
    Public Const uc_Rank As Integer = 5
    Public Const uc_Precedence As Integer = 6
    Public Const uc_OverloadHandle As Integer = 7
    Public Const uc_OverloadCount As Integer = 8
    Public Const uc_ByteSize As Integer = 9
    Public Const uc_ArgCount As Integer = 10
    Public Const uc_DataType As Integer = 12
    Public Const uc_Handle As Integer = 13
    Public Const uc_Value As Integer = 14
    Public Const uc_Property As Integer = 15

    ' Error numbers
    Public Const uc_Err_None As Integer = 0
    Public Const uc_Err_Dynamically_Defined As Integer = 1
    Public Const uc_Err_Syntax_Error As Integer = 2
    Public Const uc_Err_Undefined_Identifier As Integer = 3
    Public Const uc_Err_Unknown_Error As Integer = 4
    Public Const uc_Err_Unrecognized_Pattern As Integer = 5
    Public Const uc_Err_Unrecognized_Command As Integer = 6
    Public Const uc_Err_Datatype_Mismatch As Integer = 7
    Public Const uc_Err_Invalid_Argument_Count As Integer = 8
    Public Const uc_Err_Invalid_Definition As Integer = 9
    Public Const uc_Err_CodeBlock_Error As Integer = 10
    Public Const uc_Err_Undefined_Callback As Integer = 11
    Public Const uc_Err_ErrMsgAlreadyDefined As Integer = 12
    Public Const uc_Err_ItemCannotBeModified As Integer = 13
    Public Const uc_Err_Unrecognized_Member As Integer = 14

    Public Const uc_Err_Array_Bounds_Exceeded As Integer = 20
    Public Const uc_Err_Float_Denormal_Operand As Integer = 21
    Public Const uc_Err_Float_Divide_By_Zero As Integer = 22
    Public Const uc_Err_Float_Inexact_Result As Integer = 23
    Public Const uc_Err_Float_Invalid_Operation As Integer = 24
    Public Const uc_Err_Float_Overflow As Integer = 25
    Public Const uc_Err_Float_Stack_Check As Integer = 26
    Public Const uc_Err_Float_Underflow As Integer = 27
    Public Const uc_Err_Integer_Divide_By_Zero As Integer = 28
    Public Const uc_Err_Integer_Overflow As Integer = 29
    Public Const uc_Err_Privileged_Instruction As Integer = 30

    ' FPU Control Word Settings
    Public Const uc_FPU_Mask_InvalidOp As Integer = 1
    Public Const uc_FPU_Mask_DenormalOp As Integer = 2
    Public Const uc_FPU_Mask_ZeroDivide As Integer = 4
    Public Const uc_FPU_Mask_Overflow As Integer = 8
    Public Const uc_FPU_Mask_Underflow As Integer = 16
    Public Const uc_FPU_Mask_PrecisionLoss As Integer = 32

    Public Const uc_FPU_Precision_Single As Integer = 0
    Public Const uc_FPU_Precision_Double As Integer = 256
    Public Const uc_FPU_Precision_Extended As Integer = 768

    Public Const uc_FPU_Round_Even As Integer = 0
    Public Const uc_FPU_Round_Down As Integer = 1024
    Public Const uc_FPU_Round_Up As Integer = 2048
    Public Const uc_FPU_Round_Toward As Integer = 3072


    Public Const ucAbort As Integer = 0
    Public Const ucResume As Integer = 1
    Public Const ucReRaise As Integer = 2

    ' Data type handler callback action modes
    Public Const uc_TypeHandler_Store As Integer = 2
    Public Const uc_TypeHandler_StringOutput As Integer = 3
    Public Const uc_TypeHandler_Free As Integer = 4
    Public Const uc_TypeHandler_FuncRet As Integer = 5
    Public Const uc_TypeHandler_Copy As Integer = 6
    Public Const uc_TypeHandler_Alloc As Integer = 7
    Public Const uc_TypeHandler_Reset As Integer = 8

    Public Const uc_Callback_Undefined As Integer = 0
    ' Returns error

    ' Data Type callbacks
    Public Const uc_Complex As Integer = 1
    Public Const uc_Currency As Integer = 2
    Public Const uc_Double As Integer = 3
    Public Const uc_Extended As Integer = 4
    Public Const uc_Int8 As Integer = 5
    Public Const uc_Int8u As Integer = 6
    Public Const uc_Int16 As Integer = 7
    Public Const uc_Int16u As Integer = 8
    Public Const uc_Int32 As Integer = 9
    Public Const uc_Int32u As Integer = 10
    Public Const uc_Int64 As Integer = 11
    Public Const uc_Int64u As Integer = 12
    Public Const uc_Single As Integer = 13
    Public Const uc_String As Integer = 14
    Public Const uc_String_LPCSTR As Integer = 15
    Public Const uc_String_Fixed As Integer = 16
    Public Const uc_String_Wide As Integer = 17
    Public Const uc_Stack As Integer = 18
    Public Const uc_Void As Integer = 19
    Public Const uc_User_Type = 20   

    Public Const uc_Convert_Generic As Integer = 23
    Public Const uc_Convert_Double_Extended As Integer = 24
    Public Const uc_Convert_Int8_Extended As Integer = 25
    Public Const uc_Convert_Int8u_Extended As Integer = 26
    Public Const uc_Convert_Int16_Extended As Integer = 27
    Public Const uc_Convert_Int16u_Extended As Integer = 28
    Public Const uc_Convert_Int32_Extended As Integer = 29
    Public Const uc_Convert_Int32u_Extended As Integer = 30
    Public Const uc_Convert_Int64_Extended As Integer = 31
    Public Const uc_Convert_Int64u_Extended As Integer = 32
    Public Const uc_Convert_Single_Extended As Integer = 33
    Public Const uc_Convert_Extended_Double As Integer = 37
    Public Const uc_Convert_Extended_Single As Integer = 38
    Public Const uc_Convert_Extended_Int16u As Integer = 39
    Public Const uc_Convert_Extended_Int32 As Integer = 40
    Public Const uc_Convert_Complex_Extended As Integer = 41
    Public Const uc_Convert_Extended_Complex As Integer = 42

    ' Default built-in routines.

    Public Const uc_Op_Negate_Extended As Integer = 43
    Public Const uc_Op_UnaryPlus_Extended As Integer = 44
    Public Const uc_Op_Percentage_Extended As Integer = 45
    Public Const uc_Op_StrConcat As Integer = 46
    Public Const uc_Op_Add_Int32 As Integer = 47
    Public Const uc_Op_Add_Extended As Integer = 48
    Public Const uc_Op_Add_Complex As Integer = 49
    Public Const uc_Op_Subtract_Int32 As Integer = 50
    Public Const uc_Op_Subtract_Extended As Integer = 51
    Public Const uc_Op_Multiply_Int32 As Integer = 52
    Public Const uc_Op_Multiply_Extended As Integer = 53
    Public Const uc_Op_Multiply_Complex As Integer = 54
    Public Const uc_Op_Divide_Int32 As Integer = 55
    Public Const uc_Op_Divide_Extended As Integer = 56
    Public Const uc_Op_Mod_Int32 As Integer = 57
    Public Const uc_Op_Mod_Extended As Integer = 58
    Public Const uc_Op_PowerOf_ExtToExt As Integer = 59
    Public Const uc_Op_PowerOf_ExtToLng As Integer = 60
    Public Const uc_Op_PowerOf_CplxToCplx As Integer = 61

    Public Const uc_Op_GreaterThan_Extended As Integer = 62
    Public Const uc_Op_GreaterOrEqual_Extended As Integer = 63
    Public Const uc_Op_LessThan_Extended As Integer = 64
    Public Const uc_Op_LessOrEqual_Extended As Integer = 65
    Public Const uc_Op_Equal_Extended As Integer = 66
    Public Const uc_Op_NotEqual_Extended As Integer = 67

    Public Const uc_Op_GreaterThan_Str As Integer = 68
    Public Const uc_Op_GreaterOrEqual_Str As Integer = 69
    Public Const uc_Op_LessThan_Str As Integer = 70
    Public Const uc_Op_LessOrEqual_Str As Integer = 71
    Public Const uc_Op_Equal_Str As Integer = 72
    Public Const uc_Op_NotEqual_Str As Integer = 73

    Public Const uc_Op_Not_Int32 As Integer = 74
    Public Const uc_Op_And_Int32 As Integer = 75
    Public Const uc_Op_Or_Int32 As Integer = 76
    Public Const uc_Op_Xor_Int32 As Integer = 77
    Public Const uc_Op_Eqv_Int32 As Integer = 78
    Public Const uc_Op_Imp_Int32 As Integer = 79

    Public Const uc_Op_AndAlso As Integer = 80
    Public Const uc_Op_OrElse As Integer = 81

    Public Const uc_Op_Factorial As Integer = 82

    Public Const uc_Func_IIf As Integer = 83
    Public Const uc_Func_IIf_Str As Integer = 84

    Public Const uc_Func_Sin As Integer = 85
    Public Const uc_Func_Cos As Integer = 86
    Public Const uc_Func_Tan As Integer = 87
    Public Const uc_Func_Atan As Integer = 88
    Public Const uc_Func_Ceil As Integer = 89
    Public Const uc_Func_Abs_Extended As Integer = 90
    Public Const uc_Func_Abs_Int32 As Integer = 91
    Public Const uc_Func_Exp As Integer = 92
    Public Const uc_Func_Log As Integer = 93
    Public Const uc_Func_Floor As Integer = 94
    Public Const uc_Func_SquareRoot As Integer = 95
    Public Const uc_Func_BaseConvert As Integer = 96

    Public Const uc_Func_ExprHandle As Integer = 97
    Public Const uc_Func_VarPtr As Integer = 98
    Public Const uc_Func_uCalc As Integer = 99
    Public Const uc_Func_uCalcStr As Integer = 100
    Public Const uc_Func_ucAddr As Integer = 101
    Public Const uc_Func_ValueAtAddr As Integer = 102

    Public Const uc_Func_Asc As Integer = 103
    Public Const uc_Func_Chr As Integer = 104

    Public Const uc_Func_For As Integer = 105
    Public Const uc_Func_Loop As Integer = 107

    Public Const uc_Func_LoadLibrary As Integer = 108
    Public Const uc_Func_GetProcAddress As Integer = 109

    Public Const uc_NullString As Integer = 110
    Public Const uc_True As Integer = 111

    Public Const uc_Func_Peek = 112
    Public Const uc_Func_Poke = 113

    Public Const uc_Func_Int As Integer = 115
    Public Const uc_Func_Frac As Integer = 116
    Public Const uc_Func_Sgn As Integer = 117

    Public Const uc_Func_PushData_Stack As Integer = 120
    ' Public Const uc_Func_PopHandle_Stack As Integer = 121
    Public Const uc_Func_PopNum_Stack As Integer = 122
    Public Const uc_Func_PopStr_Stack As Integer = 123
    Public Const uc_Func_ReadHandle_Stack As Integer = 124
    Public Const uc_Func_ReadNum_Stack As Integer = 125
    Public Const uc_Func_ReadStr_Stack As Integer = 126
    Public Const uc_Func_Count_Stack As Integer = 127
    Public Const uc_Op_Concat_Stack As Integer = 128
    Public Const uc_Func_Populate_Stack As Integer = 129

    Public Const uc_Insert_Table As Integer = 130
    Public Const uc_Delete_Table As Integer = 131
    Public Const uc_Index_Table As Integer = 132
    Public Const uc_Handle_Table As Integer = 133
    Public Const uc_HandleB_Table As Integer = 134

    Public Const uc_Func_StackFormat As Integer = 135

    Public Const uc_SetVariableValue As Integer = 140
    Public Const uc_SetVariableValueAnyType As Integer = 140
    Public Const uc_SetVariableValueLong As Integer = 141
    Public Const uc_SetVariableValueDouble As Integer = 142
    Public Const uc_SetVariableValueExtended As Integer = 143

    ' Misc other callbacks
    Public Const uc_EvaluateAddr As Integer = 150
    Public Const uc_EvaluateTurboAddr As Integer = 151
    Public Const uc_ExceptionHelper As Integer = 152
    Public Const uc_DefaultErrorHandler As Integer = 153
    Public Const uc_Raise_Error As Integer = 154

    ' Interpreter addresses
    Public Const uc_Interp_DefHandle As Integer = 160     ' DWord Ptr
    Public Const uc_Interp_ExitCommand As Integer = 161   ' String Ptr
    Public Const uc_Interp_LastResultNum As Integer = 163 ' Extended Ptr
    Public Const uc_Interp_LastResultStr As Integer = 164 ' String Ptr
    Public Const uc_Interp_LineContinue As Integer = 165
    Public Const uc_Interp_MainPrompt As Integer = 166
    Public Const uc_Interp_MultiLinePrompt As Integer = 167
    Public Const uc_Interp_Prefix As Integer = 168
    Public Const uc_Interp_Postfix As Integer = 169
    Public Const uc_Interp_Tab As Integer = 170
    Public Const uc_Interp_Insert As Integer = 171

    Public Const uc_Op_Ext_Plus_Complex As Integer = 190
    Public Const uc_Op_Ext_Times_Complex As Integer = 191

    Public Const uc_Func_If_ElseIf As Integer = 195
    Public Const uc_Func_SetSyntaxParams As Integer = 196
    Public Const uc_Func_SpecialUCase As Integer = 197
    Public Const uc_Func_Rand As Integer = 198
    Public Const uc_Func_Batch_Eval As Integer = 199

    Public Const uc_Op_Add_Double As Integer = 201
    Public Const uc_Op_Subtract_Double As Integer = 202
    Public Const uc_Op_Multiply_Double As Integer = 203
    Public Const uc_Op_Divide_Double As Integer = 204
    Public Const uc_Op_Mod_Double As Integer = 205
    Public Const uc_Op_PowerOf_DblToDbl As Integer = 206
    Public Const uc_Op_PowerOf_DblToLng As Integer = 207

    Public Const uc_Func_Sin_Dbl As Integer = 208
    Public Const uc_Func_Cos_Dbl As Integer = 209
    Public Const uc_Func_Tan_Dbl As Integer = 210
    Public Const uc_Func_Atan_Dbl As Integer = 211
    Public Const uc_Func_Ceil_Dbl As Integer = 212
    Public Const uc_Func_Abs_Dbl As Integer = 213
    Public Const uc_Func_Exp_Dbl As Integer = 214
    Public Const uc_Func_Log_Dbl As Integer = 215
    Public Const uc_Func_SquareRoot_Dbl As Integer = 216

    Public Const uc_Convert_Double_Int32 As Integer = 218
    Public Const uc_Convert_Int32_Double As Integer = 219

    Public Const ucTrue As Integer = 1
    Public Const ucFalse As Integer = 0

    Public Const uc_First As Integer = 1
    Public Const uc_Last As Integer = -1

    ' Trig Modes
    Public Const uc_ReturnTrigMode As Integer = 0
    Public Const uc_Radians As Integer = 1
    Public Const uc_Degrees As Integer = 2
    Public Const uc_Grad As Integer = 3

    ' End Of Constants

    Public Delegate Sub ucCallback(ByVal Expr As Integer)
    Public Delegate Function ucErrCallback(ByVal t As Integer) As Integer

    Public ucIsInitialized As Integer
    Public ucExtended As Integer, ucString As Integer, ucLPCSTR As Integer, ucFixedString As Integer, ucDouble As Integer, ucSingle As Integer
    Public ucLong As Integer, ucDword As Integer, ucComplex As Integer, ucByte As Integer, ucTable As Integer, ucVoid As Integer, ucStack As Integer
    Public ucSortedList As Integer

    Public Declare Function uCalc_ Lib "ucFMP296.dll" Alias "uCalc" (ByVal ucCommand As Integer, _
           ByVal TextArg As String, ByVal MiscArg1 As Integer, ByVal MiscArg2 As Integer, _
           ByVal ReturnPtr As Integer, ByVal t As Integer) As Integer

    Public Declare Function uCalc__ Lib "ucFMP296.dll" Alias "uCalc" (ByVal ucCommand As Integer, _
           ByVal IgnoreTextArg As Integer, ByVal MiscArg1 As Integer, ByVal MiscArg2 As Integer, _
           ByVal ReturnPtr As Integer, ByVal t As Integer) As Integer

    Public Declare Function uCalc____ Lib "ucFMP296.dll" Alias "uCalc" (ByVal ucCommand As Integer, _
           ByVal TextArg As String, ByVal ItemAddress As ucCallback, ByVal MiscArg2 As Integer, _
           ByVal ReturnPtr As Integer, ByVal t As Integer) As Integer

    Public Declare Function uCalc_____ Lib "ucFMP296.dll" Alias "uCalc" (ByVal ucCommand As Integer, _
           ByVal TextArg As String, ByVal ItemAddress As ucErrCallback, ByVal MiscArg2 As Integer, _
           ByVal ReturnPtr As Integer, ByVal t As Integer) As Integer

    Public Declare Function ucEvaluate Lib "ucFMP296.dll" Alias "ucEvaluateDbl" (ByVal Item As Integer) As Double
    Public Declare Function ucExprThread Lib "ucFMP296.dll" (ByVal Expr As Integer) As Integer
    Public Declare Function ucParam Lib "ucFMP296.dll" Alias "ucParamDbl" (ByVal Expr As Integer, ByVal pIndex As Integer) As Double
    Public Declare Function ucParamLng Lib "ucFMP296.dll" (ByVal Expr As Integer, ByVal pIndex As Integer) As Integer
    Public Declare Function ucParamDbl Lib "ucFMP296.dll" (ByVal Expr As Integer, ByVal pIndex As Integer) As Double
    Public Declare Function ucParamStr Lib "ucFMP296.dll" (ByVal Expr As Integer, ByVal pIndex As Integer) As String
    Public Declare Function ucParamHandle Lib "ucFMP296.dll" (ByVal Expr As Integer, ByVal pIndex As Integer) As Integer
    Public Declare Function ucParamCount Lib "ucFMP296.dll" (ByVal Expr As Integer) As Integer
    Public Declare Function ucStrReturn Lib "ucFMP296.dll" (ByVal TextPtr As Integer) As String
    Public Declare Sub ucReturn Lib "ucFMP296.dll" Alias "ucReturnDbl" (ByVal Expr As Integer, ByVal ReturnValue As Double)
    Public Declare Sub ucReturnDbl Lib "ucFMP296.dll" (ByVal Expr As Integer, ByVal ReturnValue As Double)
    Public Declare Sub ucReturnStr_ Lib "ucFMP296.dll" Alias "ucReturnStr" (ByVal Expr As Integer, ByVal ReturnValue As String)
    Public Declare Sub ucSetValueDbl Lib "ucFMP296.dll" Alias "ucSetVariableValueDbl" _
           (ByVal ItemPtr As Integer, ByVal NewValue As Double)
    Public Declare Sub ucSetValueStr Lib "ucFMP296.dll" Alias "ucSetVariableValueStr" _
           (ByVal ItemPtr As Integer, ByVal NewValue As String)
    Public Declare Sub ucSetVariableValue Lib "ucFMP296.dll" Alias "ucSetVariableValueDbl" _
           (ByVal Item As Integer, ByVal NewValue As Double)
    Public Declare Sub ucSetVariableValueStr Lib "ucFMP296.dll" (ByVal Item As Integer, ByVal NewValue As String)

    Public Function uCalc(ByVal ucCommand As Integer, ByVal TextArg As String, _
                   Optional ByVal MiscArg1 As Integer = 0, Optional ByVal MiscArg2 As Integer = 0, _
                   Optional ByVal ReturnPtr As Integer = 0, Optional ByVal t As Integer = 0) As Integer
        If ucIsInitialized = ucFalse Then Call ucInitialize()
        uCalc = uCalc_(ucCommand, TextArg, MiscArg1, MiscArg2, ReturnPtr, t)
    End Function

    Public Function uCalc(ByVal ucCommand As Integer, ByVal TextArg As String, _
                   ByVal CallbackAddress As ucErrCallback, Optional ByVal Ignore1 As Integer = 0, Optional ByVal Ignore2 As Integer = 0, Optional ByVal t As Integer = 0) As Integer
        If ucIsInitialized = ucFalse Then Call ucInitialize()
        uCalc = uCalc_____(ucCommand, TextArg, CallbackAddress, 0, 0, t)
    End Function

    Public Function uCalc(ByVal ucCommand As Integer) As Integer
        If ucIsInitialized = ucFalse Then Call ucInitialize()
        uCalc = uCalc_(ucCommand, "", 0, 0, 0, 0)
    End Function

    Public Function uCalcStr(ByVal ucCommand As Integer, Optional ByVal TextArg As String = "", _
                   Optional ByVal MiscArg1 As Integer = 0, Optional ByVal MiscArg2 As Integer = 0, _
                   Optional ByVal ReturnPtr As Integer = 0, Optional ByVal t As Integer = 0) As String
        If ucIsInitialized = ucFalse Then Call ucInitialize()
        uCalcStr = ucStrReturn(uCalc_(ucCommand, TextArg, MiscArg1, MiscArg2, ReturnPtr, t))
    End Function

    Public Function uCalcB(ByVal ucCommand As Integer, Optional ByVal TextArg As Integer = 0, _
                   Optional ByVal MiscArg1 As Integer = 0, Optional ByVal MiscArg2 As Integer = 0, _
                   Optional ByVal ReturnPtr As Integer = 0, Optional ByVal t As Integer = 0) As Integer
        If ucIsInitialized = ucFalse Then Call ucInitialize()
        uCalcB = uCalc__(ucCommand, TextArg, MiscArg1, MiscArg2, ReturnPtr, t)
    End Function

    Public Function ucAddr(ByVal AddressIndex As Integer) As Integer
        ucAddr = uCalcB(uc_GetCodeAddr, 0, AddressIndex)
    End Function

    Public Function ucDefine(ByVal Definition As String, Optional ByVal Arg1 As Integer = 0, Optional ByVal Arg2 As Integer = 0, _
                      Optional ByVal Arg3 As Integer = 0, Optional ByVal t As Integer = 0) As Integer
        ucDefine = uCalc(uc_Define, Definition, Arg1, Arg2, Arg3, t)
    End Function

    Public Function ucDefineFunction(ByVal Definition As String, Optional ByVal CallbackAddress As ucCallback = Nothing, Optional ByVal t As Integer = 0) As Integer
        If IsNothing(CallbackAddress) Then
            ucDefineFunction = uCalc(uc_Define, "Func: " + Definition, 0, 0, 0, t)
        Else
            If ucIsInitialized = ucFalse Then Call ucInitialize()
            ucDefineFunction = uCalc____(uc_Define, "Func:: " + Definition, CallbackAddress, 0, 0, t)
        End If
    End Function

    Public Function ucDefineOperator(ByVal Definition As String, Optional ByVal CallbackAddress As ucCallback = Nothing, Optional ByVal t As Integer = 0) As Integer
        If IsNothing(CallbackAddress) Then
            ucDefineOperator = uCalc(uc_Define, "Op: " + Definition, 0, 0, 0, t)
        Else
            If ucIsInitialized = ucFalse Then Call ucInitialize()
            ucDefineOperator = uCalc____(uc_Define, "Op:: " + Definition, CallbackAddress, 0, 0, t)
        End If
    End Function

    Public Function ucDefineSyntax(ByVal Definition As String, Optional ByVal Rank As Integer = 1, Optional ByVal t As Integer = 0) As Integer
        ucDefineSyntax = uCalc(uc_DefineSyntax, Definition, Rank, 0, 0, t)
    End Function

    Public Function ucDefineVariable(ByVal Definition As String, Optional ByVal ItemAddress As Integer = 0, Optional ByVal t As Integer = 0) As Integer
        Dim ItemDef$
        ItemDef$ = "Var: " + Definition
        If ItemAddress <> 0 Then ItemDef$ = ItemDef$ + " At " + Str(ItemAddress)
        ucDefineVariable = uCalc(uc_Define, ItemDef$, 0, 0, 0, t)
    End Function

    Public Function ucEval(ByVal Expr As String, Optional ByVal t As Integer = 0) As Double
        Dim ItemPtr As Integer

        ItemPtr = ucParse(Expr, 0, t)
        ucEval = ucEvaluate(ItemPtr)
        ucReleaseItem(ItemPtr)
    End Function

    Public Function ucEvalStr(ByVal Expr As String, Optional ByVal ExprType As Integer = 0, Optional ByVal t As Integer = 0) As String
        ucEvalStr = uCalcStr(uc_EvalStr, Expr, ExprType, 0, 0, t)
    End Function

    Public Function ucEvaluateStr(ByVal Item As Integer) As String
        ucEvaluateStr = ucStrReturn(uCalcB(uc_EvaluateStr, 0, Item))
    End Function

    Public Function ucExpand(ByVal Expr As String, Optional ByVal t As Integer = 0) As String
        ucExpand = uCalcStr(uc_Expand, Expr, 0, 0, 0, t)
    End Function

    Public Function ucErrorMessage(Optional ByVal ErrNum As Integer = 0, Optional ByVal t As Integer = 0) As String
        ucErrorMessage = ucStrReturn(uCalcB(uc_GetErrorMessage, 0, ErrNum, 0, 0, t))
    End Function

    Public Function ucGetError(Optional ByVal t As Integer = 0) As Integer
        ucGetError = uCalcB(uc_GetErrorNumber, 0, 0, 0, 0, t)
    End Function
    Public Function ucError(Optional ByVal t As Integer = 0) As Integer
        ucError = uCalcB(uc_GetErrorNumber, 0, 0, 0, 0, t)
    End Function
    Public Function ucRaiseError(ByVal Expr As Integer, ByVal ErrorNum As Integer) As Integer
        ucRaiseError = uCalcB(uc_SetErrorNumber, 0, ErrorNum, Expr, 0, ucExprThread(Expr))
    End Function
    Public Sub ucRaiseErrorMessage(ByVal Expr As Integer, ByVal ErrMessage As String)
        uCalc(uc_SetErrorMessage, ErrMessage, uc_Err_Dynamically_Defined, 0, 0, ucExprThread(Expr))
        uCalc(uc_SetErrorNumber, "", uc_Err_Dynamically_Defined, Expr, 0, ucExprThread(Expr))
    End Sub
    Public Function ucSetError(ByVal ErrorNum As Integer, Optional ByVal t As Integer = 0) As Integer
        ucSetError = uCalcB(uc_SetErrorNumber, 0, ErrorNum, 0, 0, t)
    End Function
    Public Function ucErrSymbol(ByVal t As Integer) As String
        ucErrSymbol = ucStrReturn(uCalcB(uc_GetSymbol, 0, 0, 0, 0, t))
    End Function
    Public Function ucErrLocation(ByVal t As Integer) As Integer
        ucErrLocation = uCalcB(uc_GetLocation, 0, 0, 0, 0, t)
    End Function

    'Public Function ucGetCodeBlock(...) As String
    '      ...
    'End Function

    Public Function ucGetExpr(Optional ByVal t As Integer = 0) As String
        ucGetExpr = ucStrReturn(uCalcB(uc_GetExpression, 0, 0, 0, 0, t))
    End Function

    Public Function ucGetItemHandle(ByVal SymbolName As String, Optional ByVal ucProperties As Integer = 0, Optional ByVal t As Integer = 0) As Integer
        ucGetItemHandle = uCalc(uc_GetItemData, SymbolName, 0, uc_Handle, ucProperties, t)
    End Function

    'Public Function ucGetNextItem(ByVal Expr As String, ByVal i As Integer, Optional ByVal t As Integer = 0) As String
    '      ucGetNextItem = uCalcStr(uc_GetNextItem, Expr, 0, 0, VarPtr(i), t)
    'End Function

    Public Function ucGetSymbol(Optional ByVal t As Integer = 0) As String
        ucGetSymbol = ucStrReturn(uCalcB(uc_GetSymbol, 0, 0, 0, 0, t))
    End Function

    Public Function ucGetTrigMode() As Integer
        ucGetTrigMode = uCalcB(uc_GetTrigMode)
    End Function

    Public Function ucInterpret(ByVal Expr As String, Optional ByVal ExprType As Integer = 0, Optional ByVal t As Integer = 0) As String
        ucInterpret = uCalcStr(uc_EvalStr, Expr, ExprType, 1, 0, t)
    End Function

    Public Function ucLicense(ByVal LicenseOption As Integer, Optional ByVal L1 As Integer = 0, Optional ByVal L2 As Integer = 0, Optional ByVal L3 As Integer = 0) As Integer
        ucLicense = uCalc__(uc_License, L1, LicenseOption, L2, L3, 0)        
    End Function

    Public Function ucNewThread(Optional ByVal ParentThread As Integer = 0) As Integer
        ucNewThread = uCalcB(uc_NewThread, 0, ParentThread)
    End Function

    Public Function ucParamExpr(ByVal Expr As Integer, ByVal pIndex As Integer) As Integer
        ucParamExpr = ucParamHandle(Expr, pIndex)
    End Function

    Public Function ucParse(ByVal Expr As String, Optional ByVal ExprType As Integer = 0, Optional ByVal t As Integer = 0) As Integer
        ucParse = uCalc(uc_Parse, Expr, ExprType, 0, 0, t)
    End Function

    Public Function ucReleaseItem(ByVal ucItem As Integer) As Integer
        ucReleaseItem = uCalcB(uc_ReleaseItem, 0, ucItem)
    End Function

    Public Sub ucReturnStr(ByVal Expr As Integer, ByVal ReturnValue As String)
        ucReturnStr_(Expr, ReturnValue)
    End Sub

    Public Function ucSetErrMsg(ByVal ErrIndex As Integer, ByVal ErrMessage As String, Optional ByVal t As Integer = 0) As Integer
        ucSetErrMsg = uCalc(uc_SetErrorMessage, ErrMessage, ErrIndex, 0, 0, t)
    End Function

    Public Function ucSetErrorNumber(ByVal ErrorNumber As Integer, Optional ByVal t As Integer = 0) As Integer
        ucSetErrorNumber = uCalcB(uc_SetErrorNumber, 0, ErrorNumber, 0, 0, t)
    End Function

    Public Sub ucSetTrigMode(ByVal TrigMode As Integer)
        uCalcB(uc_SetTrigMode, 0, TrigMode)
    End Sub

    Function ucInitialize() As Integer
        ucIsInitialized = ucTrue

        ucInitialize = ucLicense(uc_License_Demo)

        ucSetErrMsg(uc_Err_None, "No error")
        ucSetErrMsg(uc_Err_Syntax_Error, "Syntax error")
        ucSetErrMsg(uc_Err_Undefined_Identifier, "Undefined identifier")
        ucSetErrMsg(uc_Err_Unknown_Error, "Unknown error")
        ucSetErrMsg(uc_Err_Unrecognized_Pattern, "Unrecognized pattern")
        ucSetErrMsg(uc_Err_Unrecognized_Command, "Unrecognized command")
        ucSetErrMsg(uc_Err_Datatype_Mismatch, "Data type mismatch")
        ucSetErrMsg(uc_Err_CodeBlock_Error, "Code block delimiter error")
        ucSetErrMsg(uc_Err_Invalid_Argument_Count, "Invalid number of arguments")
        ucSetErrMsg(uc_Err_Invalid_Definition, "Invalid definition")
        ucSetErrMsg(uc_Err_Undefined_Callback, "Undefined callback")
        ucSetErrMsg(uc_Err_ErrMsgAlreadyDefined, "Error message already defined")
        ucSetErrMsg(uc_Err_ItemCannotBeModified, "This item cannot be modified")
        ucSetErrMsg(uc_Err_Unrecognized_Member, "Unrecognized member")
        ucSetErrMsg(uc_Err_Array_Bounds_Exceeded, "Array bounds exceeded")
        ucSetErrMsg(uc_Err_Float_Denormal_Operand, "Denormal operand")
        ucSetErrMsg(uc_Err_Float_Divide_By_Zero, "Division by 0")
        ucSetErrMsg(uc_Err_Float_Inexact_Result, "Inexact result")
        ucSetErrMsg(uc_Err_Float_Invalid_Operation, "Invalid operation")
        ucSetErrMsg(uc_Err_Float_Overflow, "Floating point overflow")
        ucSetErrMsg(uc_Err_Float_Stack_Check, "Floating point stack error")
        ucSetErrMsg(uc_Err_Float_Underflow, "Floating point underflow")
        ucSetErrMsg(uc_Err_Integer_Divide_By_Zero, "Integer division by 0")
        ucSetErrMsg(uc_Err_Integer_Overflow, "Integer overflow")
        ucSetErrMsg(uc_Err_Privileged_Instruction, "Privileged instruction denied")

        ' Extended, Double, and Single must be defined in that order, and prior to other types.
        ucExtended = ucDefine("DataType: Extended ~~ Size: 10 ~~ TypeHandler: #", ucAddr(uc_Extended))
        ucDouble = ucDefine("DataType: Double   ~~ Size: 8  ~~ TypeHandler: # ~~ ConvertsTo: Extended, #", ucAddr(uc_Double), ucAddr(uc_Convert_Double_Extended))
        ucSingle = ucDefine("DataType: Single   ~~ Size: 4  ~~ TypeHandler: # ~~ ConvertsTo: Extended, #", ucAddr(uc_Single), ucAddr(uc_Convert_Single_Extended))
        ucLong = ucDefine("DataType: Long     ~~ Size: 4  ~~ TypeHandler: # ~~ ConvertsTo: Extended, #", ucAddr(uc_Int32), ucAddr(uc_Convert_Int32_Extended))
        ucDword = ucDefine("DataType: Dword    ~~ Size: 4  ~~ TypeHandler: # ~~ ConvertsTo: Extended, #", ucAddr(uc_Int32u), ucAddr(uc_Convert_Int32u_Extended))
        ucString = ucDefine("DataType: String   ~~ Size: 4  ~~ TypeHandler: # ~~ ConvertsTo: LPCSTR", ucAddr(uc_String))
        ucFixedString = ucDefine("DataType: FixedString ~~ TypeHandler: # ~~ ConvertsTo: String ~~ ConvertsFrom: String", ucAddr(uc_String_Fixed))
        ucByte = ucDefine("DataType: Byte     ~~ Size: 1  ~~ TypeHandler: # ~~ ConvertsTo: Extended, #", ucAddr(uc_Int8u), ucAddr(uc_Convert_Int8u_Extended))
        ucLPCSTR = ucDefine("DataType: LPCSTR               ~~ TypeHandler: # ~~ ConvertsTo: String", ucAddr(uc_String_LPCSTR))
        ucStack = ucDefine("DataType: Stack    ~~ Size: 4  ~~ TypeHandler: #", ucAddr(uc_Stack))
        ucSortedList = ucDefine("DataType: SortedList ~~ Size: 4  ~~ TypeHandler: #", ucAddr(uc_Stack))
        ucTable = ucDefine("DataType: Table    ~~ Size: 4      ~~ TypeHandler: #", ucAddr(uc_Stack))
        ucVoid = ucDefine("DataType: Void     ~~ Size: 10 ~~ TextData: Ok ~~ TypeHandler: #", ucAddr(uc_Void))

        ucDefine("DataType: Double ~~ ConvertsFrom: Byte ~~ ConvertsTo: Byte")
        ucDefine("DataType: Double ~~ ConvertsTo: Long, #", ucAddr(uc_Convert_Double_Int32))
        ucDefine("DataType: Long   ~~ ConvertsTo: Double, #", ucAddr(uc_Convert_Int32_Double))
        ucDefine("DataType: Double ~~ ConvertsFrom: Dword ~~ ConvertsTo: Dword")
        ucDefine("DataType: Double ~~ ConvertsFrom: Single ~~ ConvertsTo: Single")

        ucExtended = ucDefine("DataType: Extended ~~ ConvertsTo: Long, #", ucAddr(uc_Convert_Extended_Int32))
        ucExtended = ucDefine("DataType: Extended ~~ ConvertsTo: Dword, #", ucAddr(uc_Convert_Extended_Int32))
        ucExtended = ucDefine("DataType: Extended ~~ ConvertsTo: Double, #", ucAddr(uc_Convert_Extended_Double))
        ucExtended = ucDefine("DataType: Extended ~~ ConvertsTo: Single, #", ucAddr(uc_Convert_Extended_Single))
        ucExtended = ucDefine("DataType: Extended ~~ ConvertsTo: Byte")

        ucDword = ucDefine("DataType: Dword ~~ ConvertsTo: Long")

        ucDefine("Pattern:[\x00\x01\x02]") ' Reserved characters
        ucDefine("Pattern:\x03 ~~ \x03 ~~ DataType: #2", ucQuotedText + ucLiteral, ucString)
        ucDefine("Pattern:\x05") ' Define Codeblock bootstrap
        ucDefine("Pattern:\x06 ~~ \x07", ucCodeBlock)
        ucDefine("Pattern: :")
        ucDefine("Pattern: :=")
        ucDefine("Pattern:\[ ~~ \]", ucCodeBlock)
        ucDefine("Pattern:\{ ~~ \} ~~ DataType: #2 ~~ Address: #3", ucCodeBlock, ucStack, ucAddr(uc_Func_Populate_Stack))
        ucDefine("Pattern:[\q] ~~ [\q] ~~ DataType: #2", ucQuotedText + ucLiteral, ucString)
        ucDefine("Pattern:['] ~~ ['] ~~ DataType: #2", ucQuotedText + ucLiteral, ucString)
        ucDefine("Pattern:\x0D\x0A", ucStatementSep) ' Carriage Return
        ucDefine("Pattern:;", ucStatementSep)
        ucDefine("Pattern:~t", ucCurrentThread)
        ucDefine("Pattern:~Eval", ucEvalInsert)
        ucDefine("Pattern:~Eval_1 ~~ PassOnce", ucEvalInsert)
        ucDefine("Pattern:~Eval_P", ucEvalDuringParse)
        ucDefine("Pattern:~Expand", ucExpandInsert)
        ucDefine("Pattern:~Expand_1 ~~ PassOnce", ucExpandInsert)
        ucDefine("Pattern:\.", ucMemberAccess)
        ucDefine("Pattern:\~\~")
        ucDefine("Pattern:,", ucArgSeparator)
        ucDefine("Pattern:\( ~~ \)", ucCodeBlock)
        ucDefine("Pattern:[ \t]+", ucWhiteSpace)
        ucDefine("Pattern:[\|+/*^$&#\-=%@!`\\<>?]+", ucReducible) ' For operators
        ucDefine("Pattern:([0-9]*\.)?[0-9]+(e[-+]?[0-9]+)? ~~ DataType: #2", ucLiteral, ucDouble) ' Numeric
        ucDefine("Pattern:[a-z_][0-9a-z_]* ~~ Name: AlphaNum", ucAlphaNumeric)

        ucDefineSyntax("Op: {Name} '{' {Operand} '}' [As {type}] ::=" _
                      + "Param: {Operand} ~~ Name: {Name} ~~ DataType: {type} ~~ Properties: " + Str$(ucPrefix + ucOperator))
        ucDefineSyntax("Op: '{' {Operand} '}' {Name} [As {type}] ::=" _
                      + "Param: {Operand} ~~ Name: {Name} ~~ DataType: {type} ~~ Properties: " + Str$(ucPostfix + ucOperator))
        ucDefineSyntax("Op: '{' {LeftOp} '}' {Name} '{' {RightOp} '}' [As {type}] ::=" _
                      + "Param: {LeftOp} ~~ Param: {RightOp} ~~ Name: {Name} ~~ DataType: {type} ~~ Properties: " + Str$(ucInfix + ucOperator))

        ucDefineSyntax("Op: {Def} { At {addr} | ':=' {Expr:'.+'} } ::= Op: {Def} {addr: ~~ Address: {addr} ~~ StdCall} {Expr: ~~ FuncBody: {Expr}}")
        ucDefineSyntax("Op: {pValue:' *[0-9]+ '} {Def} ::= Precedence: {pValue} ~~ Op: {Def}")
        ucDefineSyntax("Op:: {Def:'.+'} ::= NativeCall ~~ Address: # ~~ Op: {Def}")
        ucDefineSyntax("Op:: Native: ::= Op:: ")

        ucDefineSyntax("Var: {VarName:'[ ]*[a-z_][0-9a-z_]*'} [As {Type}] [= {Value}] [At {Addr:' .+'}] ::=" _
                       + "Variable ~~ Name: {VarName}" _
                       + "{Type: ~~ DataType: {Type}}" _
                       + "{Value: ~~ Value: {Value}}" _
                       + "{Addr: ~~ Address: {Addr}}")
        ucDefineSyntax("Var: {VarName:'[ ]*[a-z_][0-9a-z_]*'} As AnyType ::= AnyType ~~ Var: {VarName}")
        ucDefineSyntax("Var: {PassBy:'( +ByRef)|( +ByVal)|( +ByHandle)|( +ByExpr)'} ::= {PassBy} ~~ Var:")
        ucDefineSyntax("Var: {Def} ... ::= Var: {Def} ~~ VariableArgList")
        ucDefineSyntax("Var: ... ::= Var: _ ~~ VariableArgList")
        ucDefineSyntax("Var: {name:' *[_a-z]*'} = {quote:' *[\x22\x27]'} ::= Var: {name} As String = {quote}")

        ucDefineSyntax("Const: {Def:'.*'} ::= Var: {Def} ~~ Properties: " + Str$(ucLock))
        ucDefineSyntax("=- ::= = -")

        ucDefineSyntax("Func: {FuncName} ([{ParamList}]) [As {type:' +[a-z]+[a-z0-9]*'}] [{ At {addr} | = {Def:'.+'} }] ::= " _
                       + "Params: ({ParamList}) ~~ Name: {FuncName} ~~ DataType: {type}" _
                       + "~~ Properties: " + Str$(ucFunction + ucPrefix) _
                       + "{addr: ~~ Address: {addr} ~~ StdCall} ~~ FuncBody: {Def}")

        ucDefineSyntax("Func:: {Def:'.+'} ::= NativeCall ~~ Address: # ~~ Func: {Def}")
        ucDefineSyntax("Func:: Native: ::= Func:: ")


        ucDefineSyntax("Params: ([{SingleParam}]) ::= IsParam ~~ { {SingleParam: Var: {SingleParam}} }")
        ucDefineSyntax("Params: ({Variable} = {Default}) ::= Params: ({Variable} ~~ TextData: {Default})")
        ucDefineSyntax("Params: ({Param1}, {OtherParams}) ::= Params: ({Param1}) ~~ Params: ({OtherParams})")
        ucDefineSyntax("Param: {ParamDef} ~~ ::= IsParam ~~ { Var: {ParamDef} } ~~")

        ucDefine("Op:: -{x}    ~~ Precedence: 25", ucAddr(uc_Op_Negate_Extended))
        ucDefine("Op:: {x As String}+{y As String} As String ~~ Precedence: 10", ucAddr(uc_Op_StrConcat))
        ucDefine("Op:: {x As Long}+{y As Long} As Long ~~ Precedence: 10", ucAddr(uc_Op_Add_Int32))

        ucExtended = ucDefine("DataType: Extended ~~ ConvertsTo: Complex, #", ucAddr(uc_Convert_Extended_Complex))
        ucComplex = ucDefine("DataType: Complex ~~ {Var: Real As Extended} ~~ {Var: Imag As Extended = 1} ~~ TypeHandler: #", ucAddr(uc_Complex))
        ucDefine("Pattern:#i ~~ DataType: #2", ucLiteral, ucComplex)
        ucDefine("Op:: {x As Complex}+{y As Complex} As Complex ~~ Precedence: 10", ucAddr(uc_Op_Add_Complex))
        ucDefine("Op:: {x As Complex}*{y As Complex} As Complex ~~ Precedence: 10", ucAddr(uc_Op_Multiply_Complex))

        ucDefine("Op:: {x}>{y}  As Long ~~ Precedence: 5", ucAddr(uc_Op_GreaterThan_Extended))
        ucDefine("Op:: {x}<{y}  As Long ~~ Precedence: 5", ucAddr(uc_Op_LessThan_Extended))
        ucDefine("Op:: {x}>={y} As Long ~~ Precedence: 5", ucAddr(uc_Op_GreaterOrEqual_Extended))
        ucDefine("Op:: {x}<={y} As Long ~~ Precedence: 5", ucAddr(uc_Op_LessOrEqual_Extended))
        ucDefine("Op:: {x}<>{y} As Long ~~ Precedence: 5", ucAddr(uc_Op_NotEqual_Extended))
        ucDefine("Op:: {x}=={y} As Long ~~ Precedence: 5", ucAddr(uc_Op_Equal_Extended))

        ucDefine("Op:: {x As String}>{y As String}  As Long ~~ Precedence: 5", ucAddr(uc_Op_GreaterThan_Str))
        ucDefine("Op:: {x As String}<{y As String}  As Long ~~ Precedence: 5", ucAddr(uc_Op_LessThan_Str))
        ucDefine("Op:: {x As String}>={y As String} As Long ~~ Precedence: 5", ucAddr(uc_Op_GreaterOrEqual_Str))
        ucDefine("Op:: {x As String}<={y As String} As Long ~~ Precedence: 5", ucAddr(uc_Op_LessOrEqual_Str))
        ucDefine("Op:: {x As String}<>{y As String} As Long ~~ Precedence: 5", ucAddr(uc_Op_NotEqual_Str))
        ucDefine("Op:: {x As String}=={y As String} As Long ~~ Precedence: 5", ucAddr(uc_Op_Equal_Str))

        ucDefine("Op:: {x As Long} And     {y As Long} As Long ~~ Precedence: 4", ucAddr(uc_Op_And_Int32))
        ucDefine("Op:: {x}         AndAlso {ByExpr y}          ~~ Precedence: 4", ucAddr(uc_Op_AndAlso))
        ucDefine("Op:: {x As Long} Or      {y As Long} As Long ~~ Precedence: 3", ucAddr(uc_Op_Or_Int32))
        ucDefine("Op:: {x}         OrElse  {ByExpr y}          ~~ Precedence: 3", ucAddr(uc_Op_OrElse))

        ucDefine("Op:: {x As Double}+{y As Double} As Double ~~ Precedence: 10", ucAddr(uc_Op_Add_Double))
        ucDefine("Op:: {x As Double}-{y As Double} As Double ~~ Precedence: 10", ucAddr(uc_Op_Subtract_Double))
        ucDefine("Op:: {x As Double}*{y As Double} As Double ~~ Precedence: 20", ucAddr(uc_Op_Multiply_Double))
        ucDefine("Op:: {x As Double}/{y As Double} As Double ~~ Precedence: 20", ucAddr(uc_Op_Divide_Double))
        ucDefine("Op:: {x As Double} Mod {y As Double} As Double ~~ Precedence: 20", ucAddr(uc_Op_Mod_Double))
        ucDefine("Op:: {x As Double}^{y As Double} As Double ~~ Precedence: 30", ucAddr(uc_Op_PowerOf_DblToDbl))

        ucDefine("Op:: {x As Long}!  ~~ Precedence: 40", ucAddr(uc_Op_Factorial))
        ucDefine("Op:: {x As Long}\{y As Long} As Long ~~ Precedence: 20", ucAddr(uc_Op_Divide_Int32))

        ucDefine("Func:: Sin(x As Double) As Double", ucAddr(uc_Func_Sin_Dbl))
        ucDefine("Func:: Cos(x As Double) As Double", ucAddr(uc_Func_Cos_Dbl))
        ucDefine("Func:: Tan(x As Double) As Double", ucAddr(uc_Func_Tan_Dbl))
        ucDefine("Func:: Atan(x As Double) As Double", ucAddr(uc_Func_Atan_Dbl))
        ucDefine("Func:: Abs(x As Double) As Double", ucAddr(uc_Func_Abs_Dbl))
        ucDefine("Func:: Exp(x As Double) As Double", ucAddr(uc_Func_Exp_Dbl))
        ucDefine("Func:: Log(x As Double) As Double", ucAddr(uc_Func_Log_Dbl))
        ucDefine("Func:: Ceil(x As Double) As Long", ucAddr(uc_Func_Ceil_Dbl))
        ucDefine("Func:: Sqr(x As Double) As Double", ucAddr(uc_Func_SquareRoot_Dbl))
        ucDefine("Func:: Int(x)", ucAddr(uc_Func_Int))
        ucDefine("Func:: Frac(x)", ucAddr(uc_Func_Frac))
        ucDefine("Func:: Sgn(x)", ucAddr(uc_Func_Sgn))
        ucDefine("Func:: Rand(x = 1)", ucAddr(uc_Func_Rand))
        ucDefine("Func:: Rand(x As Long, y As Long)", ucAddr(uc_Func_Rand))

        ucDefine("Syntax: Max({x}, {y}) ::= IIf({x} > {y}, {x}, {y})")
        ucDefine("Syntax: Max({x}, {y}, {etc}) ::= Max({x}, Max({y}, {etc}))")
        ucDefine("Syntax: Min({x}, {y}) ::= IIf({x} < {y}, {x}, {y})")
        ucDefine("Syntax: Min({x}, {y}, {etc}) ::= Min({x}, Min({y}, {etc}))")

        ucDefine("Func:: BaseConvert(Number As String, Base As Long)", ucAddr(uc_Func_BaseConvert))

        ucDefine("Func:: iif(cond As Long, ByExpr TruePart As String, ByExpr FalsePart As String = '') As String", ucAddr(uc_Func_IIf_Str))
        ucDefine("Func:: iif(cond As Long, ByExpr TruePart, ByExpr FalsePart = 0)", ucAddr(uc_Func_IIf))
        ucDefine("Func: Inf() = 1/0")
        ucDefine("Func: NaN() = 0/0")

        ucDefine("Func:: Error(Message As String)", ucAddr(uc_Raise_Error))
        ucDefine("Func:: ucAddr(index)", ucAddr(uc_Func_ucAddr))
        ucDefine("Func:: ValueAtAddr(DataType As Dword, Address As Dword, Index As Long = 0) ~~ ValueAtAddr", ucAddr(uc_Func_ValueAtAddr))
        ucDefine("Func:: BatchEval(ByHandle Var As Double, ByHandle VarArray As Double, ByHandle ResultArray As Double, " _
                +"Count As Long, ByExpr Expr As Double) As Void", ucAddr(uc_Func_Batch_Eval))

        ucDefine("Var: NullStr As String At #", ucAddr(uc_NullString))
        ucDefine("Func:: uCalc(Command As Long, TextArg As String = NullStr, MiscArg1 As Long = 0," _
                + "MiscArg2 As Long = 0, ReturnPtr As Long = 0, t As Long = 0) As Long", ucAddr(uc_Func_uCalc))

        ucDefine("Func:: uCalcStr(Command As Long, TextArg As String = NullStr, MiscArg1 As Long = 0," _
                + "MiscArg2 As Long = 0, ReturnPtr As Long = 0, t As Long = 0) As String", ucAddr(uc_Func_uCalcStr))

        ucDefine("Syntax: Precedence({Item}) ::= uCalc("+Str$(uc_GetItemData)+", {Item}, 0, "+Str$(uc_Precedence)+", 0, ~t)")

        ucDefine("Func:: uc_Loop(ByExpr DoCondition, ByExpr Expression As AnyType, ByExpr LoopCondition) As Void", ucAddr(uc_Func_Loop))
        ucDefine("Func:: uc_For(ByHandle Counter As AnyType, Start, Finish, Step, ByExpr Expr As AnyType) As Void", ucAddr(uc_Func_For))

        ucDefine("Func:: Asc(Character As String, Position As Long = 1) As Long", ucAddr(uc_Func_Asc))
        ucDefine("Func:: Chr(Code As Long) As String", ucAddr(uc_Func_Chr))

        ucDefine("Var: _Number As String = '([0-9]*\.)?[0-9]+(e[-+]?[0-9]+)?'")
        ucDefine("Var: _HexNumber As String = '([0-9a-z]*\.)?[0-9a-z]+(e[-+]?[0-9]+)?'")
        ucDefine("Var: _Alpha As String = '[a-z_][0-9a-z_]*'")
        ucDefine("Syntax: {Num:_Number}{Alpha:_Alpha} ::= {Num}*{Alpha}")
        ucDefine("Syntax: {'#b'}{Number:_Number} ::= ~Eval(BaseConvert('{Number}', 2))")
        ucDefine("Syntax: {'#o'}{Number:_Number} ::= ~Eval(BaseConvert('{Number}', 8))")
        ucDefine("Syntax: {'#h'}{Number:_HexNumber} ::= ~Eval(BaseConvert('{Number}', 16))")

        ucDefine("Const: uc_Define = " + Str$(uc_Define))
        ucDefine("Syntax: ucDefine({Def}) ::= uCalc(uc_Define, {Def}, 0, 0, 0, ~t)")

        ucDefine("Syntax: Local([{' +'}]{Variable:'[^=, ]+'}[{etc}], {Expr}) ::= ~Eval_P(ucDefine('Var: {Variable} {etc}')) {Expr} ~Eval_P(ucRename('{Variable}', ''))")
        ucDefine("Syntax: Local({Variable1}, {OtherVariables}, {Expr}) ::= Local({Variable1}, Local({OtherVariables}, {Expr}))")

        ucDefine("Const: uc_DefineSyntax = " + Str$(uc_DefineSyntax))
        ucDefine("Func:: SetSyntaxParams(Params As String, Expr As String, t As Dword = 0) As String", ucAddr(uc_Func_SetSyntaxParams))
        ucDefineSyntax("Macro: {name} [{args:'\([^\)]*\)'}] = {replacement} ::= Syntax: ~Eval(SetSyntaxParams('{args}', '{name}{args} ::= {replacement}'))")

        ucDefine("Const: uc_GetItemData = " + Str$(uc_GetItemData))
        ucDefine("Const: uc_SetItemData = " + Str$(uc_SetItemData))
        ucDefine("Const: uc_SymbolName = " + Str$(uc_SymbolName))
        ucDefine("Const: uc_Handle = " + Str$(uc_Handle))
        ucDefine("Syntax: ucHandle({Item}) ::= uCalc(uc_GetItemData, {Item}, 0, uc_Handle, 0, ~t)")
        ucDefine("Syntax: ucRename({OldName}, {NewName})" _
                +"::= uCalc(uc_SetItemData, {NewName}, ucHandle({OldName}), uc_SymbolName, 0, ~t)")

        ' Arrays
        ucDefine("Const: uc_Address = " + Str$(uc_Address))
        ucDefine("Const: uc_DataType = " + Str$(uc_DataType))
        ucDefineSyntax("Address({Item}) ::= ~Eval(uCalc(uc_GetItemData, '{Item}', 0, uc_Address, 0, ~t))")
        ucDefineSyntax("DataType({Item})::= ~Eval(uCalc(uc_GetItemData, '{Item}', 0, uc_DataType, 0, ~t))")
        ucDefine("PassOnce ~~ Syntax: NextDef {etc:'.+'} ::= NextDef {etc}")

        ucDefineSyntax("Var: {'[ ]*'}{ArrayName:_Alpha} ({MaxIndex}) [{etc}]" _
        + "::= Count: {MaxIndex} ~~ Var: {ArrayName} {etc} ~~ NextDef ~~" _
        + "Syntax: {ArrayName} ({Index}) ::= ValueAtAddr(DataType({ArrayName}), Address({ArrayName}), {Index})")

        ' Assign Value to Variable
        ucDefine("Func:: SetVar(ByHandle Var As AnyType, ByHandle Value As String) As Void", ucAddr(uc_SetVariableValueAnyType))
        ucDefine("Func:: SetVar(ByHandle Var As AnyType, ByHandle Value As Double) As Void", ucAddr(uc_SetVariableValueAnyType))
        ucDefine("Func:: SetVar(ByHandle Var As Double, ByHandle Value As Double) As Void", ucAddr(uc_SetVariableValueDouble))

        ucDefine("DefaultType: Double")
    End Function
End Module